package labTasks;

/*
 fib(i): i, for i <= 1
         fib(i-1) + fib(i-2), otherwise
 */

public class Fibonacci {
	
	/*
    naive version: use two recursive calls
    in body
	 */
	
	public static int naiveFibonacci(int i) {
		// ...
	}
	
	/*
     constant space and linear time in Scheme:
     
     (define (iterfibonacci f1 f2 i n)
       (if (= i n)
         f2
         (iterfibonacci f2 (+ f1 f2) (+ i 1) n)))
         
	 */
	
	private static int iterFibonacciTry(int f1, int f2, int i, int n) {
	   // ...
	}
	
	/* linear space and linear time in Java */
	
	public static int iterativeFibonacciTry(int n) {
		// ...
	}
	
	/*
	 real iterative behavior can only be achieved
	 with a loop in Java: 
	 constant space and linear time
	 */
	
	public static int iterativeFibonacci(int n) {
		// ...
	}
}
